/**
 * This is the base class for all TinyMCE events.
 *
 * @class tinymce.Event
 */

/**
 * Prevents the default action of an event to be executed.
 *
 * @method preventDefault
 */

/**
 * Prevents the default action of an event to be executed.
 *
 * @method preventDefault
 */

/**
 * Stops the event from propagating up to listeners on parent objects.
 *
 * @method stopPropagation
 */

/**
 * Prevents the event from propagating to listeners on the same object.
 *
 * @method stopImmediatePropagation
 */

/**
 * Returns true/false if the default action is to be prevented or not.
 *
 * @method isDefaultPrevented
 * @return {Boolean} True/false if the event is to be execured or not.
 */

/**
 * Returns true/false if the event propagation is stopped or not.
 *
 * @method isPropagationStopped
 * @return {Boolean} True/false if the event propagation is stopped or not.
 */

/**
 * Returns true/false if the event immediate propagation is stopped or not.
 *
 * @method isImmediatePropagationStopped
 * @return {Boolean} True/false if the event immediate propagation is stopped or not.
 */

/**
 * The event type name for example "click".
 *
 * @property {String} type
 */

/**
 * @include tinymce.ContentEvent.js
 * @include tinymce.CommandEvent.js
 * @include tinymce.ProgressStateEvent.js
 * @include tinymce.FocusEvent.js
 * @include tinymce.ResizeEvent.js
 */
